/********************************************************
ColorDisplay class v1.0
Viktor Goltvyanitsa
http://www.fwkit.com/
Usage:
var initColor:String="8288CB";
var cm:ColorMatch = new ColorMatch(initColor);
createEmptyMovieClip("mainDisplay",0);
var cd:ColorDisplay = new ColorDisplay(mainDisplay,25,25,cm,"normal");
//var cd:ColorDisplay = new ColorDisplay(mainDisplay,25,25,cm,"websafe");
********************************************************/
import com.fwkit.color.ColorRectangle;
import com.fwkit.color.ColorMatch;

class	com.fwkit.color.ColorDisplay extends MovieClip {
		static var version:String = "1.0.0.0";
		private var cm:ColorMatch;
		private var clrLite2="DFDFE3";
		private var model:String;
		private var rectanleObj:ColorRectangle;
		public var thisBaseClip:MovieClip;
		
		
	public function ColorDisplay(targetClip:MovieClip,initW:Number,initH:Number,parentColorMatch:ColorMatch,viewModel:String){
			if(targetClip!=undefined){
			model=viewModel||"normal";
			if(model!="normal"&&model!="websafe")model="normal";
			thisBaseClip=targetClip;
			cm=parentColorMatch;
			thisBaseClip.createEmptyMovieClip("ColorDisplay",0);
			setSize(initW,initH,cm,model);
		}
	}
	
	public function setSize(targW:Number,targH:Number,parentColorMatch:ColorMatch,model:String):Void{
		var fillColor:String;
		if(model=="normal"){
			fillColor=cm.getRGBstr();
		}else{
			fillColor=cm.nearestWebSafe();
		}
		var pointRectangle:ColorRectangle = new ColorRectangle(thisBaseClip.ColorDisplay,0,0,clrLite2, 60, 2,fillColor,100,targW,targH);
		rectanleObj=pointRectangle;
	}
	
	public function setCoordinates(crdX:Number,crdY:Number):Void{
		thisBaseClip.ColorDisplay._x=crdX||0;
		thisBaseClip.ColorDisplay._y=crdY||0;
	}
	
	public function getX():Number{
		return thisBaseClip.ColorDisplay._x;
	}
	
	public function getY():Number{
		return thisBaseClip.ColorDisplay._y
	}
	
	public function move(newX:Number,newY:Number):Void{
		setCoordinates(newX,newY);
	}
	
	public function setVisible(mode:Boolean):Void{
		thisBaseClip.ColorDisplay._visible=mode;	
	}
	
	public function refresh(colorMatchObj:ColorMatch):Void{
		var fillColor:String;
		if(model=="normal"){
			fillColor=cm.getRGBstr();
		}else{
			fillColor=cm.nearestWebSafe();
		}		
		rectanleObj.setFillRGB(fillColor);
		rectanleObj.refresh();
	}
	
	public function call():Void{
		refresh(cm);
	}
	
	public function deleteDisplay():Boolean{
		if(thisBaseClip.ColorDisplay!=undefined){
			thisBaseClip.ColorDisplay.unloadMovie();
			return true
		}else{
			return false;
		}
	}
	
	public function setModel(newModel:String):Void{
		if(newModel!="normal"&&newModel!="websafe"){
			model="normal";
		}else{
			model=newModel;
		}
	}
	

}