/********************************************************
ColorDisplayValueLabel class v1.0
Viktor Goltvyanitsa
http://www.fwkit.com/
Usage:
createEmptyMovieClip("firstLabel",7);
var valLabel:ColorDisplayValueLabel = new ColorDisplayValueLabel(firstLabel,"testLabel","magenta","byte",200,15);
********************************************************/
import com.fwkit.utils.ArrayUtils;

class	com.fwkit.color.ColorDisplayValueLabel extends MovieClip {
		static var version:String = "1.0.0.0";
		private var namesColorModes:Array=["byte","percent","degree"];
		private var namesColorComponents:Array=["<b>R</b>ed","<b>G</b>reen","<b>B</b>lue","<b>C</b>yan","<b>M</b>agenta","<b>Y</b>ellow","Blac<b>k</b>","<b>H</b>ue","<b>S</b>aturation","<b>V</b>alue","<b>L</b>ightness"];

		private var namesCheckColorComponents:Array=["red","green","blue","cyan","magenta","yellow","black","hue","saturation","value","lightness"];
		private var nameNewHolderClip:String;
		private var thisTxt:String;
		private var arrayMatch:ArrayUtils;
		private var clrLite2="DFDFE3";
		public var thisBaseClip:MovieClip;
		
		
	public function ColorDisplayValueLabel(targetClip:MovieClip,nameNewClip:String,Component:String,Mode:String,coordX:Number,coordY:Number){
		if(targetClip!=undefined&&nameNewClip!=undefined&&Component!=undefined&&Mode!=undefined){
			var thisArrayMatch:ArrayUtils=new ArrayUtils();
			arrayMatch=thisArrayMatch;
			thisBaseClip=targetClip;
			nameNewHolderClip=nameNewClip;
			if(thisBaseClip[nameNewHolderClip]==undefined){
				thisBaseClip.createEmptyMovieClip(nameNewHolderClip,thisBaseClip.getNextHighestDepth());
			}
			setCoordinates(coordX,coordY);
			thisBaseClip[nameNewHolderClip].createTextField("txtLabel",-4,3,0,3,3);
			thisBaseClip[nameNewHolderClip].txtLabel.html=true;
			thisBaseClip[nameNewHolderClip].txtLabel.selectable=false;
			thisBaseClip[nameNewHolderClip].txtLabel.multiline=false;
			thisBaseClip[nameNewHolderClip].txtLabel.wordWrap=false;
			thisBaseClip[nameNewHolderClip].txtLabel.autoSize="left";
			setTxt(Component,Mode);
		}
	}
	
	public function setTxt(Component:String,Mode:String):Void{
		if(Component!=undefined&&Mode!=undefined){
			var indexFirstItem:Number=arrayMatch.findValueInArray(namesCheckColorComponents,Component.toLowerCase());
			var indexSecondItem:Number=arrayMatch.findValueInArray(namesColorModes,Mode.toLowerCase());
			if(indexFirstItem>=0&&indexSecondItem>=0){
				thisTxt=namesColorComponents[indexFirstItem]+", "+namesColorModes[indexSecondItem];
				thisBaseClip[nameNewHolderClip].txtLabel.htmlText="<FONT face='Verdana' size='11'>"+thisTxt+"</font>";
			}			
		}
	}
	
	public function setCoordinates(crdX:Number,crdY:Number):Void{
		thisBaseClip[nameNewHolderClip]._x=crdX||0;
		thisBaseClip[nameNewHolderClip]._y=crdY||0;
	}
	
	public function setVisible(mode:Boolean):Void{
		thisBaseClip[nameNewHolderClip]._visible=mode;	
	}
	
	public function getWidth():Number{
		if(thisBaseClip[nameNewHolderClip].txtLabel!=undefined){
			return thisBaseClip[nameNewHolderClip].txtLabel._width;
		}else{
			return 0;	
		}
	}
	
	public function deleteLabel():Boolean{
		if(thisBaseClip[nameNewHolderClip]!=undefined){
			thisBaseClip[nameNewHolderClip].unloadMovie();
			return true
		}else{
			return false;
		}
	}

}