/********************************************************
ColorMatchCallBack class v1.0
Viktor Goltvyanitsa
http://www.fwkit.com/
********************************************************/
import com.fwkit.color.ColorMatch;
import com.fwkit.utils.ArrayUtils;

class	com.fwkit.color.ColorMatchCallBack {
	
		static var version:String = "1.0.0.0";
		private var cm:ColorMatch;
		private var calledObjects:Array=new Array();
		private var namesCalledObjects:Array=new Array();
		private var arrayMatch:ArrayUtils;
		
		
	public function ColorMatchCallBack(currentColorMatch:ColorMatch){
		if(currentColorMatch!=undefined)cm=currentColorMatch;
			var thisArrayMatch:ArrayUtils=new ArrayUtils();
			arrayMatch=thisArrayMatch;
	}
	
	public function setObject(newObject,nameObject:String):Boolean{
		if(newObject!=undefined&&nameObject!=undefined){
			if(namesCalledObjects.length>0){
				var indexItem:Number=arrayMatch.findValueInArray(namesCalledObjects,nameObject);
				if(indexItem>=0){
					calledObjects[indexItem]=newObject;
					namesCalledObjects[indexItem]=nameObject;
				}else{
					calledObjects.push(newObject);
					namesCalledObjects.push(nameObject);					
				}
			}else{
				calledObjects.push(newObject);
				namesCalledObjects.push(nameObject);
			}
			return true;
		}else{
			return false
		}
	}
	
	public function removeObject(nameObject:String):Boolean{
		var indexItem:Number=arrayMatch.findValueInArray(namesCalledObjects,nameObject);
		if(indexItem>=0){
			namesCalledObjects=arrayMatch.deleteItemByIndex(namesCalledObjects,indexItem);
			calledObjects=arrayMatch.deleteItemByIndex(calledObjects,indexItem);
			return true
		}else{
			return false
		}
	}
	
	public function call():Void{
		var totalCalledObjects:Number=namesCalledObjects.length;
		if(totalCalledObjects>0){
			for(var i=0;i<totalCalledObjects;i++){
				if(calledObjects[i]!=undefined){
					calledObjects[i].call();
				}
			}
		}
	}
	
	
}